# IBM Confidential
# OCO Source Materials
# Component IBM Rational ROSE_RT BUILD : ROSE_RT
# (c) Copyright IBM Corp. [1998], [2004] .All Rights Reserved.
# 
# The source code for this program is not published or
# or otherwise divested of its trade secrets, irrespective
# of what has been deposited with the U.S. Copyright Office.
# 
# 
# Copyright (c) 1991-2003 Rational Software Corporation. All rights
# reserved.
# 
# Rational, the Rational logo, ObjecTime (and logo) are registered
# trademarks of Rational Software Corporation.
# 
# The placing of the copyright notices on Rational source code is not
# intended to mean that they are published works, but are included in the
# event of inadvertent publication. The source code of Rational contains
# trade secrets and other valuable confidential information of Rational
# Software Corporation. Rational Software Corporation and its licensors
# retain ownership to Rational Products in both source and object code
# format, and related documentation and all rights therein including
# copyrights, patents and trade secrets.
# 
# 
# U.S. Government Rights
# 
# Use, duplication, or disclosure by the U.S. Government is subject to
# restrictions set forth in the applicable Rational License Agreement
# and in DFARS 227.7202-1(a) and 227.7202-3(a) (1995), DFARS
# 252.227-7013(c)(1)(ii)(Oct 1988), FAR 12.212(a) 1995, FAR 52.227-19,
# or FAR 52.227-14, as applicable.
# 
# Unless otherwise agreed to in writing, use of Rational products is
# governed by the Rational Product License Agreement provided with
# the product.
# 

RTS_HOME=..

# libset.mk will replace this definition
# with an empty one if shared libraries are not supported

SHLIBS = $(ACTOR_SHLIB) $(TRANSPORT_SHLIB) $(DATA_SHLIB)

# Final action, after main.o and all libraries are built.

WRAPUP = $(NOP)

libraries : all
	@ $(NOP)

include $(RTS_HOME)/libset/default.mk
include $(RTS_HOME)/libset/$(LIBRARY_SET)/libset.mk
include $(RTS_HOME)/target/$(TARGET)/target.mk
include $(RTS_HOME)/config/$(CONFIG)/config.mk

# If necessary add the following to CC_CMD below.
#   $(INCLUDE_TAG)$(RTS_HOME)/config/$(CONFIG)
#   $(INCLUDE_TAG)$(RTS_HOME)/src/libset/$(LIBRARY_SET)

CC_ECHO = $(FEEDBACK) Compiling
CC_CMD  = $(CC) \
	  $(LIBSETCCFLAGS) $(TARGETCCFLAGS) $(LIBSETCCEXTRA) \
	  $(INCLUDE_TAG)$(RTS_HOME)/build-$(CONFIG) \
	  $(INCLUDE_TAG)$(RTS_HOME)/libset/$(LIBRARY_SET) \
	  $(INCLUDE_TAG)$(RTS_HOME)/target/$(TARGET) \
	  $(INCLUDE_TAG)$(RTS_HOME)/include \
	  $(INCLUDE_TAG)$(RTS_HOME)/src/target/$(TARGET_BASE) \
	  $(INCLUDE_TAG)$(RTS_HOME)/src/include \
	  $(OBJECT_OPT) $(OBJOUT_OPT) $(OBJOUT_TAG)"$@"

ACTOR_LIB       = $(RTS_LIBRARY)/libObjecTimeC$(LIB_EXT)
ACTOR_SHLIB     = $(RTS_LIBRARY)/libObjecTimeC$(SHLIB_EXT)
# DATA_LIB        = $(RTS_LIBRARY)/libObjecTimeTypes$(LIB_EXT)
# DATA_SHLIB      = $(RTS_LIBRARY)/libObjecTimeTypes$(SHLIB_EXT)
TRANSPORT_LIB   = $(RTS_LIBRARY)/libObjecTimeCTransport$(LIB_EXT)
TRANSPORT_SHLIB = $(RTS_LIBRARY)/libObjecTimeCTransport$(SHLIB_EXT)

all :		$(ACTOR_LIB)	\
		$(TRANSPORT_LIB)\
		$(SHLIBS)	\
                OTHERS
		
	@ $(WRAPUP)

# Here, we include the list of explicit dependencies.
# The rules are much too complicated for the average make program.

include depend.mk

$(ACTOR_LIB) : $(A_OBJECTS)
	@ $(FEEDBACK)
	@ $(FEEDBACK) Building $(@F) ...
	@ $(RMF) $@
	@ $(AR_CMD) $(LIBOUT_OPT) $(LIBOUT_TAG)"$@" %A.olist
	@ $(RANLIB) $@

# $(DATA_LIB) : $(D_OBJECTS)
#	@ $(FEEDBACK)
#	@ $(FEEDBACK) Building $(@F) ...
#	@ $(RMF) $@
#	@ $(AR_CMD) $(LIBOUT_OPT) $(LIBOUT_TAG)"$@" %D.olist
#	@ $(RANLIB) $@

$(TRANSPORT_LIB) : $(T_OBJECTS)
	@ $(FEEDBACK)
	@ $(FEEDBACK) Building $(@F) ...
	@ $(RMF) $@
	@ $(AR_CMD) $(LIBOUT_OPT) $(LIBOUT_TAG)"$@" %T.olist
	@ $(RANLIB) $@

$(ACTOR_SHLIB) : $(A_OBJECTS)
	@ $(FEEDBACK)
	@ $(FEEDBACK) Building $(@F) ...
	@ $(RMF) $@
	@ $(SHLIB_CMD) $(SHLIBOUT_OPT) $(SHLIBOUT_TAG)"$(@F)" %A.olist
	@ $(MV) $(@F) $@

# $(DATA_SHLIB) : $(D_OBJECTS)
#	@ $(FEEDBACK)
#	@ $(FEEDBACK) Building $(@F) ...
#	@ $(RMF) $@
#	@ $(SHLIB_CMD) $(SHLIBOUT_OPT) $(SHLIBOUT_TAG)"$(@F)" %D.olist
#	@ $(MV) $(@F) $@

$(TRANSPORT_SHLIB) : $(T_OBJECTS)
	@ $(FEEDBACK)
	@ $(FEEDBACK) Building $(@F) ...
	@ $(RMF) $@
	@ $(SHLIB_CMD) $(SHLIBOUT_OPT) $(SHLIBOUT_TAG)"$(@F)" %T.olist
	@ $(MV) $(@F) $@

OTHERS : $(M_OBJECTS)
	@ $(NOP)

FORCE :
	@ $(NOP)

# A shorter list of suffixes reduces the time spent searching for applicable
# implicit rules. This makefile doesn't rely on implicit rules so the list
# could be empty, but some implementations of make seem to think this is worth
# noting so we just put .cc in the list to eliminate those warnings.

.SUFFIXES :
.SUFFIXES : $(CPP_EXT)
